// Code generated by go-swagger; DO NOT EDIT.

package roles

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// UserRoleDeleteHandlerFunc turns a function with the right signature into a user role delete handler
type UserRoleDeleteHandlerFunc func(UserRoleDeleteParams) middleware.Responder

// Handle executing the request and returning a response
func (fn UserRoleDeleteHandlerFunc) Handle(params UserRoleDeleteParams) middleware.Responder {
	return fn(params)
}

// UserRoleDeleteHandler interface for that can handle valid user role delete params
type UserRoleDeleteHandler interface {
	Handle(UserRoleDeleteParams) middleware.Responder
}

// NewUserRoleDelete creates a new http.Handler for the user role delete operation
func NewUserRoleDelete(ctx *middleware.Context, handler UserRoleDeleteHandler) *UserRoleDelete {
	return &UserRoleDelete{Context: ctx, Handler: handler}
}

/*UserRoleDelete swagger:route DELETE /api/roles/{id} Roles userRoleDelete

Delete role

*/
type UserRoleDelete struct {
	Context *middleware.Context
	Handler UserRoleDeleteHandler
}

func (o *UserRoleDelete) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUserRoleDeleteParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
